unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ColorGrd, Gauges, Buttons, ExtCtrls, ComCtrls,
  IWControl, IWHTMLControls, ActnList, ConvertDialogBox, ShellApi;

type
  TForm3 = class(TForm)
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label3: TLabel;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    Label2: TLabel;
    ColorGrid1: TColorGrid;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button2: TButton;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Edit2: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit3: TEdit;
    Panel1: TPanel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    procedure UrlMailClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure ColorGrid1Click(Sender: TObject);
    function SmeniBoja(boja: Integer): String;
    function IzvrtiBoja(s: String):String;

  private
    { Private declarations }
  public
     { Public declarations }
  end;

var
  Form3: TForm3;
  close_bool: Boolean;
  validna_boja: Boolean;

implementation

uses winapp, StrUtils;

{$R *.dfm}
procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if (close_bool) then Form1.close;
end;


procedure TForm3.FormCreate(Sender: TObject);
begin
//polnenje na combo box
  ComboBox1.AddItem('Player with 160x120 video size',nil);
  ComboBox1.AddItem('Player with 240x180 video size',nil);
  ComboBox1.AddItem('Player with 320x240 video size',nil);
  ComboBox1.AddItem('Player with 640x480 video size',nil);
//setiranje na defaut vrednost za bojata
  validna_boja := false;  
end;


procedure TForm3.Button1Click(Sender: TObject);
var
f: TextFile;
buffer_time, color_flash, width_flash, height_flash: String;
movie_name, movie_id, auto_start, isLink: String;
begin

//parsiranje na bojata za Flash
color_flash:='';
  case ColorGrid1.Selection of
    0: color_flash:='000000';
    1: color_flash:='800000';
    2: color_flash:='008000';
    3: color_flash:='808000';
    4: color_flash:='000080';
    5: color_flash:='800080';
    6: color_flash:='408080';
    7: color_flash:='C0C0C0';
    8: color_flash:='808080';
    9: color_flash:='FF0000';
    10: color_flash:='00FF00';
    11: color_flash:='FFFF00';
    12: color_flash:='0000FF';
    13: color_flash:='FF00FF';
    14: color_flash:='00FFFF';
    15: color_flash:='FFFFFF';
  end;
//cod za proverka na vnesena boja
if (validna_boja) then color_flash:=Edit3.Text;

//tuka se generira html fajlot

if ComboBox1.Text = 'Please choose' then
  ShowMessage('Please select video size')
  else
  if RadioGroup1.ItemIndex = -1 then
     ShowMessage('Please select buffer time')
    else
      begin
//check the video size
        case ComboBox1.ItemIndex of
           0: begin width_flash:='163'; height_flash:='178'; movie_name:='flv_player_160x120.swf'; movie_id:='flv_player_160x120'; end;
           1: begin width_flash:='243'; height_flash:='243'; movie_name:='flv_player_240x180.swf'; movie_id:='flv_player_240x180'; end;
           2: begin width_flash:='323'; height_flash:='323'; movie_name:='flv_player_320x240.swf'; movie_id:='flv_player_320x240'; end;
           3: begin width_flash:='643'; height_flash:='555'; movie_name:='flv_player_640x480.swf'; movie_id:='flv_player_640x480'; end;
        end;
//see the check box
        if (CheckBox1.Checked) then auto_start:='1';
//case for buffer time:
        case RadioGroup1.ItemIndex of
          0: buffer_time:='2';
          1: buffer_time:='3';
          2: buffer_time:='5';
          3: buffer_time:='8';
        end;
//parse of link
        if (CheckBox2.Checked) then isLink := '1' else isLink:='0';
//creating of html file
        AssignFile(f,ExtractFilePath(Application.ExeName)+'html\TempHtml.html');
        Rewrite(f);
        writeln(f,'<html> <body>');
        writeln(f,'<br>');
//ispisuvanje na flash objectot
        writeln(f, '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" '
                    ,'codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="'+ width_flash +'" height="'+ height_flash+'" id="'+ movie_id+'" align="middle"> '
                    ,'<param name="allowScriptAccess" value="sameDomain" /> '
                    ,'<param name="movie" value="'+ movie_name+'" /> '
//tuka treba da se dodadat flesh vars
                    ,'<param name="FlashVars" value="file=flvs\'+Form1.clip_fileName+'&clipLength='+Form1.duration_sec+'&buttonColor='+color_flash+'&bufferTime='+buffer_time+'&autoStart='+auto_start+'&isLink='+isLink+'&linkCaption='+Edit1.Text+'&webPage='+Edit2.Text+'" />'
                    ,'<param name="quality" value="high" /> '
                    ,'<param name="bgcolor" value="#ffffff" /> '
                    ,'<embed src="'+movie_name+'?file=flvs\'+Form1.clip_fileName+'&clipLength='+Form1.duration_sec+'&buttonColor='+color_flash+'&bufferTime='+buffer_time+'&autoStart='+auto_start+'&isLink='+isLink+'&linkCaption='+Edit1.Text+'&webPage='+Edit2.Text+'" quality="high" bgcolor="#ffffff" width="'+width_flash+'" height="'+height_flash+'" name="'+movie_id+'" '
                    ,'align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" '
                    ,'pluginspage="http://www.macromedia.com/go/getflashplayer" /> </object>');
        writeln(f,'</body> </html>');
        CloseFile(f);
//display message and show the web page
{
  if MessageDlg('Would you like to see the web page',
           mtConfirmation, [mbYes,mbNo], 0,) = mrYes then
           begin
               //odi na temphtml
              ShellExecute(Application.Handle, PChar('open'), PChar(ExtractFilePath(Application.ExeName)+'html\TempHtml.html'), PChar(0), nil, SW_NORMAL);
           end;
}
ShowMessage('Web page is built');
     end;

end;



procedure TForm3.Button2Click(Sender: TObject);
begin
close_bool:=false;
Form1.Show();
Form3.Close();
end;

procedure TForm3.OnActivate(Sender: TObject);
begin
  close_bool:=true;
end;

procedure TForm3.UrlMailClick(Sender: TObject);
begin
 If (Sender is TLabel) then
  with (Sender as Tlabel) do
 ShellExecute(Application.Handle,
             PChar('open'),
             PChar(Hint),
             PChar(0),
             nil,
             SW_NORMAL);
 end;

procedure TForm3.CheckBox2Click(Sender: TObject);
begin
//ShowMessage('klikna na selektiranjeto i dali e cekirano e: ' + BoolToStr(CheckBox2.Checked));
//prikaz na polinata za vnes na linkot
if (CheckBox2.Checked) then begin
    Label7.Visible := true;
    Edit1.Visible := true;
    Label8.Visible := true;
    Edit2.Visible := true;
  end
  else begin
    Label7.Visible := false;
    Edit1.Visible := false;
    Label8.Visible := false;
    Edit2.Visible := false;
  end;
end;

procedure TForm3.Edit3Exit(Sender: TObject);
var
i,j: integer;
temp, znaci: String;
newColor: TColor;
begin
  temp:= Edit3.Text;
  znaci := '1234567890AaBbCcDdEeFf';
  j:=0;
  if ((Length(temp)=6) or (Length(temp)=0)) then
  begin
    for i:=1 to Length(temp) do
      begin
          if (not(AnsiContainsStr(znaci,temp[i]))) then
            begin
               ShowMessage('Please enter valid hexadecimal digit');
               j:=j-1;
               break;
           end
           else j:=j+1
      end;
      if (j=6) then validna_boja:=true;
   end
   else
   begin
    ShowMessage('Please enter 6 digit hexadecimal number (e.g. FFFFFF for white)');
    validna_boja := false;
   end;
   if (validna_boja) then
   begin
     newColor:=StrToInt('$00'+IzvrtiBoja(temp));
     Panel1.Color:= newColor;
   end;
end;

procedure TForm3.ColorGrid1Click(Sender: TObject);
var
newColor: TColor;
begin
  //ShowMessage('Se klikna i izbranat boja e: ' + IntToStr(ColorGrid1.Selection));
  Edit3.Text:=SmeniBoja(ColorGrid1.Selection);
  newColor:=StrToInt('$00'+IzvrtiBoja(Edit3.Text));
  Panel1.Color:= newColor;
end;

function TForm3.SmeniBoja(boja: Integer): String;
var
  boja_s: String;
begin
    case boja of
    0: boja_s:='000000';
    1: boja_s:='800000';
    2: boja_s:='008000';
    3: boja_s:='808000';
    4: boja_s:='000080';
    5: boja_s:='800080';
    6: boja_s:='408080';
    7: boja_s:='C0C0C0';
    8: boja_s:='808080';
    9: boja_s:='FF0000';
    10: boja_s:='00FF00';
    11: boja_s:='FFFF00';
    12: boja_s:='0000FF';
    13: boja_s:='FF00FF';
    14: boja_s:='00FFFF';
    15: boja_s:='FFFFFF';
  end;
  result:=boja_s;
end;

function TForm3.IzvrtiBoja(s: String):String;
var
  izvrten_s: String;
  i: Integer;
begin
  izvrten_s:='';
  i:=Length(s);
  while i>0 do
  begin
      izvrten_s:=izvrten_s+s[i-1]+s[i];
      i:=i-2;
  end;
  result:= izvrten_s;
end;

end.
