unit winapp;

interface

uses
  Windows, Messages, WinProcs, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WinTypes, ConvertDialogBox, Unit2, HTTPApp, HTTPProd,
  DosCommand, ShellApi, jpeg, ExtCtrls;

type
Tshow=(Normal, Minimized, Maximized);
    TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    DosCommand1: TDosCommand;
    Button1: TButton;
    Button5: TButton;
    Label4: TLabel;
    Label2: TLabel;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    function VratiImeNaFajl(s: String) :String;
    procedure Button5Click(Sender: TObject);
    procedure PrikaziOutput(Sender: TObject; NewLine: String; OutputType: TOutputType);
    procedure ConvertZavrshi(Sender: TObject);
    procedure ProveriConverting();
    procedure CheckFileSize();
    procedure UrlMailClick(Sender: TObject);
    
  private
  public
//promenlivi za flash: filename, duration_sec
  Output_S: String;
  clip_fileName, duration_sec: String;
  ff: TextFile;
  proverka_bool: boolean;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit3;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
ffmpeg_string: String;

timer: Integer;
begin
 Output_S:='';
 proverka_bool:=false;
//timer ako zatupa convert nogo vreme da rabote
 timer:=0;
 if OpenDialog1.Execute then
  begin
    ConvertDialog.Show();
    ffmpeg_string :='conv -i "' + OpenDialog1.FileName + '" -vcodec flv -acodec mp3 -s 240x180 -y "'+ExtractFilePath(Application.ExeName)+'html\flvs\'+VratiImeNaFajl(OpenDialog1.FileName)+'.flv"';
    DosCommand1.CommandLine:=ffmpeg_string;
    DosCommand1.Execute();
    ConvertDialog.Show();
    ShowMessage('Converting is started. Click "OK" to continue');
    while (ConvertDialog.Showing) do begin
       timer:= timer+1;
//if uslovot treba da bide nad 20
       if (timer >5) then CheckFileSize();
       Sleep(500);
    end;
//proverka_bool e dali klipot e izbisan ili ne, default value e false
   if (proverka_bool) then ShowMessage('The input video file has errors. Please check video file.')
    else proveriConverting();
//sekako da go zatvoram convert procesot
   DosCommand1.Stop;
   end;//na opendialog
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
Form3.Show;
Form1.Hide;
end;


procedure TForm1.PrikaziOutput(Sender: TObject; NewLine: String;
  OutputType: TOutputType);
begin
 Output_S:=Output_S+String(NewLine);
end;


procedure TForm1.ConvertZavrshi(Sender: TObject);
var
i, j, k: Integer;
hour_i, min_i, sec_i, time_i: Integer;
hour, min, sec: String;
temp, temp1, duration: String;
begin
//da vidime duration kolku e
 duration:='';
 hour:=''; min:=''; sec:='';
 hour_i:=0; min_i:=0; sec_i:=0;
 for i:=1 to (Length(Output_S)-7) do
 begin
     temp1:='';
     for j:=1 to 8 do temp1:=temp1+Output_S[i+j];
     if (temp1='Duration') then begin
         for k:=(i+10) to (i+18) do begin
         duration:=duration+Output_S[k];
         if k=(i+18) then begin
             hour:= ''+Output_S[k-7]+Output_S[k-6];
             hour_i:=StrToInt(hour);
             min:= ''+Output_S[k-4]+Output_S[k-3];
             min_i:=StrToInt(min);
             sec:= ''+Output_S[k-1]+Output_S[k];
             sec_i:=StrToInt(sec);
           end;
         end;
     end;
 end;//ovde zavrshuva for i uslovot

//konvertiranje na vremeto vo secundi:
 time_i:=hour_i*3600+ min_i*60+sec_i;
 duration_sec:=IntToStr(time_i);


//ovaa tuka mi e cisto za zapis vo text file, za testiranje
{
 AssignFile(ff,'tempoutput.txt');
 ReWrite(ff);
 writeln(ff,'Pocetok');
 writeln(ff,''+Output_S);
 writeln(ff,'Temp1 e:    ' +temp1);
 writeln(ff,'duration e:    ' +duration);
 writeln(ff,'hour e:    '+ hour+', min e: '+min+', i naturlih sec e: '+sec);
 writeln(ff,'duration_sec e:    ' +duration_sec);
 CloseFile(ff);
}
 ConvertDialog.Close;
end;

procedure TForm1.ProveriConverting();
var
f: file of Byte;
new_file: String;
file_size: Integer;
begin
    new_file:=ExtractFilePath(Application.ExeName)+'html\flvs\'+VratiImeNaFajl(OpenDialog1.FileName)+'.flv';
    AssignFile(f,new_file);
    reset(f);
    file_size:=FileSize(f);
    If file_size >1 then
       begin
         ShowMessage('Sucessufull converting');
//set up the filename:
         clip_fileName:= VratiImeNaFajl(OpenDialog1.FileName)+'.flv';
         ConvertDialog.Close;
         Form3.Show();
         Form1.Hide();
       end
    else ShowMessage('Unsucessufull converting, possible codec error. Please see codec list.');
end;

procedure TForm1.CheckFileSize();
var
oldfileB, newfileB: file of Byte;
oldfileS, newfileS: String;
file_size_old, file_size_new: Integer;
filename1: Array[0..500] of Char;
begin
  file_size_old:=1;  file_size_new:=1;
  try
    oldfileS:=OpenDialog1.FileName;
    AssignFile(oldfileB, oldfileS);
    reset(oldfileB);
    file_size_old:=FileSize(oldfileB);
    CloseFile(oldfileB);

    newfileS:=ExtractFilePath(Application.ExeName)+'html\flvs\'+VratiImeNaFajl(OpenDialog1.FileName)+'.flv';
    AssignFile(newfileB, newfileS);
    Reset(newfileB);
    file_size_new:= FileSize(newfileB);
    CloseFile(newfileB);
  except
    on  EInOutError do begin
         DosCommand1.Stop;
         ShowMessage('Input file is read only');
         //tuka treba da se izprishe zapocnatiot fajl
         StrPCopy(filename1,ExtractFilePath(Application.ExeName)+'html\flvs\'+VratiImeNaFajl(OpenDialog1.FileName)+'.flv');
         DeleteFile(filename1);
         proverka_bool:= true;
//prestani da vrtash
         ConvertDialog.Close;
       end;
   end;
//if uslovot treba da bide file_size_new>2*file_size_old
//ShowMessage('file_size_new '+IntToStr(file_size_new)+' file_size_old'+IntToStr(file_size_old));
    if (file_size_new>2*file_size_old) then begin
         DosCommand1.Stop;
         //erase file
         StrPCopy(filename1,newfileS);
         DeleteFile(filename1);
         //do not check the output file
//ShowMessage('file_size_new '+IntToStr(file_size_new)+' file_size_old'+IntToStr(file_size_old));
         proverka_bool:= true;
         ConvertDialog.Close;
    end;
end;

// vo ovaa funkcija treba da sredam i praznite mesta ako gi ima
function TForm1.VratiImeNaFajl(s: String) :String;
var
   i,p: integer;
   eks_bool: boolean;
   pom_name: String;
   name: String;
begin
  eks_bool := false;
  pom_name := '';
  for i:=Length(s) downto 1 do
  begin
     if s[i] = '\' then eks_bool:=false;
     if eks_bool then pom_name:= pom_name + s[i];
     if s[i]='.' then eks_bool:=true;
  end;
  name:='';
  for i:=Length(pom_name) downto 1 do name:=name+pom_name[i];
//proveri go name od prazni mesta i ako gi ima zameni gi so '_'
  while ((Pos(' ',name))>0) do
     begin
       p:=Pos(' ',name);
       name[p]:='_';
     end;
  result := name;
end;


procedure TForm1.UrlMailClick(Sender: TObject);
begin
 If (Sender is TLabel) then
  with (Sender as Tlabel) do
 ShellExecute(Application.Handle,
             PChar('open'),
             PChar(Hint),
             PChar(0),
             nil,
             SW_NORMAL);
 end;


end.
